# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

# Only need manual requires for "use base XXX;" prior to rpm 4.9
%global rpm49 %(rpm --version | perl -p -e 's/^.* (\\d+)\\.(\\d+).*/sprintf("%d.%03d",$1,$2) ge 4.009 ? 1 : 0/e')

Name:		perl-Perl-Critic-Pulp
Version:	80
Release:	1.%{__distinit}%{__distvers}
Summary:	Some add-on perlcritic policies
License:	GPLv3+
Group:		Development/Libraries
URL:		http://user42.tuxfamily.org/perl-critic-pulp/index.html
Source0:	http://search.cpan.org/CPAN/authors/id/K/KR/KRYDE/Perl-Critic-Pulp-%{version}.tar.gz
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildArch:	noarch
# Build:
BuildRequires:	perl(ExtUtils::MakeMaker)
# Run-time:
BuildRequires:	perl(base)
BuildRequires:	perl(constant)
BuildRequires:	perl(Exporter)
BuildRequires:	perl(File::Temp)
BuildRequires:	perl(IO::String) >= 1.02
BuildRequires:	perl(List::MoreUtils) >= 0.24
BuildRequires:	perl(List::Util)
BuildRequires:	perl(Pod::ParseLink)
BuildRequires:	perl(Perl::Critic) >= 1.084
BuildRequires:	perl(Perl::Critic::Policy) >= 1.084
BuildRequires:	perl(Perl::Critic::Utils) >= 1.100
BuildRequires:	perl(Perl::Critic::Utils::PPI)
BuildRequires:	perl(Perl::Critic::Violation)
BuildRequires:	perl(Pod::MinimumVersion) >= 50
BuildRequires:	perl(Pod::ParseLink)
BuildRequires:	perl(Pod::Parser)
BuildRequires:	perl(PPI) >= 1.212
BuildRequires:	perl(PPI::Document)
BuildRequires:	perl(Scalar::Util)
BuildRequires:	perl(version)
# Tests only:
BuildRequires:	perl(Data::Dumper)
BuildRequires:	perl(PPI::Dumper)
BuildRequires:	perl(Test::More)
# Optional tests only:
BuildRequires:	perl(Perl::MinimumVersion)
# Run-time:
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
Requires:	perl(IO::String) >= 1.02
Requires:	perl(List::MoreUtils) >= 0.24
Requires:	perl(Perl::Critic) >= 1.084
Requires:	perl(Pod::MinimumVersion) >= 50
Requires:	perl(PPI) >= 1.212
Requires:	perl(PPI::Document)
# This is plug-in into Test::More - depend on it even if not mentioned in the code
Requires:	perl(Test::More)
# use base XXX;
%if ! %{rpm49}
Requires:	perl(Exporter)
Requires:	perl(Perl::Critic::Policy)
Requires:	perl(Perl::Critic::Pulp::PodParser)
Requires:	perl(Perl::Critic::Violation)
Requires:	perl(Pod::Parser)
%endif

# Filter private parsers and redefinitions
%global badprovs	     Perl::MinimumVersion
%global badprovs %{badprovs}|Perl::Critic::PodParser::ProhibitVerbatimMarkup
%global badprovs %{badprovs}|Perl::Critic::Policy::Documentation::ProhibitAdjacentLinks::Parser
%global badprovs %{badprovs}|Perl::Critic::Pulp::PodMinimumVersionViolation
%global badprovs %{badprovs}|Perl::Critic::Pulp::PodParser::ProhibitBadAproposMarkup
%global badprovs %{badprovs}|Perl::Critic::Pulp::PodParser::ProhibitDuplicateSeeAlso
%global badprovs %{badprovs}|Perl::Critic::Pulp::PodParser::ProhibitLinkToSelf
%global badprovs %{badprovs}|Perl::Critic::Pulp::PodParser::ProhibitParagraphTwoDots
%global badprovs %{badprovs}|Perl::Critic::Pulp::PodParser::ProhibitUnbalancedParens
%global badprovs %{badprovs}|Perl::Critic::Pulp::PodParser::RequireFinalCut
%global badprovs %{badprovs}|Perl::Critic::Pulp::PodParser::RequireLinkedURLs
%global badprovs %{badprovs}|Perl::Critic::Pulp::ProhibitDuplicateHashKeys::Qword
%global __provides_exclude perl\\((%{badprovs})\\)\\s*$

%description
This is a collection of add-on policies for Perl::Critic. They're under
a "pulp" theme plus other themes according to their purpose (see "POLICY
THEMES" in Perl::Critic).

%prep
%setup -q -n Perl-Critic-Pulp-%{version}

# Filter unwanted provides (prior to rpm 4.9)
%global provfilt /bin/sh -c "%{__perl_provides} | grep -Evx 'perl\\((%{badprovs})\\)'"
%define __perl_provides %{provfilt}

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -exec rm -f {} \;
%{_fixperms} %{buildroot}

%check
make test

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc Changes COPYING README
%{perl_vendorlib}/Perl/
%{_mandir}/man3/Perl::Critic::Policy::CodeLayout::ProhibitFatCommaNewline.3pm*
%{_mandir}/man3/Perl::Critic::Policy::CodeLayout::ProhibitIfIfSameLine.3pm*
%{_mandir}/man3/Perl::Critic::Policy::CodeLayout::RequireFinalSemicolon.3pm*
%{_mandir}/man3/Perl::Critic::Policy::CodeLayout::RequireTrailingCommaAtNewline.3pm*
%{_mandir}/man3/Perl::Critic::Policy::Compatibility::ConstantLeadingUnderscore.3pm*
%{_mandir}/man3/Perl::Critic::Policy::Compatibility::ConstantPragmaHash.3pm*
%{_mandir}/man3/Perl::Critic::Policy::Compatibility::Gtk2Constants.3pm*
%{_mandir}/man3/Perl::Critic::Policy::Compatibility::PerlMinimumVersionAndWhy.3pm*
%{_mandir}/man3/Perl::Critic::Policy::Compatibility::PodMinimumVersion.3pm*
%{_mandir}/man3/Perl::Critic::Policy::Compatibility::ProhibitUnixDevNull.3pm*
%{_mandir}/man3/Perl::Critic::Policy::Documentation::ProhibitAdjacentLinks.3pm*
%{_mandir}/man3/Perl::Critic::Policy::Documentation::ProhibitBadAproposMarkup.3pm*
%{_mandir}/man3/Perl::Critic::Policy::Documentation::ProhibitDuplicateHeadings.3pm*
%{_mandir}/man3/Perl::Critic::Policy::Documentation::ProhibitDuplicateSeeAlso.3pm*
%{_mandir}/man3/Perl::Critic::Policy::Documentation::ProhibitLinkToSelf.3pm*
%{_mandir}/man3/Perl::Critic::Policy::Documentation::ProhibitParagraphEndComma.3pm*
%{_mandir}/man3/Perl::Critic::Policy::Documentation::ProhibitParagraphTwoDots.3pm*
%{_mandir}/man3/Perl::Critic::Policy::Documentation::ProhibitUnbalancedParens.3pm*
%{_mandir}/man3/Perl::Critic::Policy::Documentation::ProhibitVerbatimMarkup.3pm*
%{_mandir}/man3/Perl::Critic::Policy::Documentation::RequireEndBeforeLastPod.3pm*
%{_mandir}/man3/Perl::Critic::Policy::Documentation::RequireFinalCut.3pm*
%{_mandir}/man3/Perl::Critic::Policy::Documentation::RequireLinkedURLs.3pm*
%{_mandir}/man3/Perl::Critic::Policy::Miscellanea::TextDomainPlaceholders.3pm*
%{_mandir}/man3/Perl::Critic::Policy::Miscellanea::TextDomainUnused.3pm*
%{_mandir}/man3/Perl::Critic::Policy::Modules::ProhibitModuleShebang.3pm*
%{_mandir}/man3/Perl::Critic::Policy::Modules::ProhibitPOSIXimport.3pm*
%{_mandir}/man3/Perl::Critic::Policy::Modules::ProhibitUseQuotedVersion.3pm*
%{_mandir}/man3/Perl::Critic::Policy::ValuesAndExpressions::ConstantBeforeLt.3pm*
%{_mandir}/man3/Perl::Critic::Policy::ValuesAndExpressions::NotWithCompare.3pm*
%{_mandir}/man3/Perl::Critic::Policy::ValuesAndExpressions::ProhibitArrayAssignAref.3pm*
%{_mandir}/man3/Perl::Critic::Policy::ValuesAndExpressions::ProhibitBarewordDoubleColon.3pm*
%{_mandir}/man3/Perl::Critic::Policy::ValuesAndExpressions::ProhibitDuplicateHashKeys.3pm*
%{_mandir}/man3/Perl::Critic::Policy::ValuesAndExpressions::ProhibitEmptyCommas.3pm*
%{_mandir}/man3/Perl::Critic::Policy::ValuesAndExpressions::ProhibitFiletest_f.3pm*
%{_mandir}/man3/Perl::Critic::Policy::ValuesAndExpressions::ProhibitNullStatements.3pm*
%{_mandir}/man3/Perl::Critic::Policy::ValuesAndExpressions::ProhibitUnknownBackslash.3pm*
%{_mandir}/man3/Perl::Critic::Policy::ValuesAndExpressions::RequireNumericVersion.3pm*
%{_mandir}/man3/Perl::Critic::Policy::ValuesAndExpressions::UnexpandedSpecialLiteral.3pm*
%{_mandir}/man3/Perl::Critic::Pulp.3pm*
%{_mandir}/man3/Perl::Critic::Pulp::PodParser.3pm*
%{_mandir}/man3/Perl::Critic::Pulp::Utils.3pm*

%changelog
* Sat Jul 27 2013 Paul Howarth <paul@city-fan.org> - 80-1
- Update to 80
  - New policy Documentation::ProhibitParagraphEndComma
  - Tests UnexpandedSpecialLiteral.t don't exercise __PACKAGE__ => across
    newline since that might be going to change in Perl 5.20 (CPAN RT#87307)

* Wed Jul 24 2013 Paul Howarth <paul@city-fan.org> - 79-2
- Perl 5.18 rebuild

* Wed Mar 20 2013 Paul Howarth <paul@city-fan.org> - 79-1
- Update to 79
  - Fix ProhibitFatCommaNewline load version.pm for perl 5.8 (CPAN RT#83990)

* Sat Mar 16 2013 Paul Howarth <paul@city-fan.org> - 78-1
- Update to 78
  - New policies CodeLayout::ProhibitIfIfSameLine,
    CodeLayout::ProhibitFatCommaNewline
- Add patch to fix code with perl < 5.10 (CPAN RT#83990)

* Thu Feb 28 2013 Paul Howarth <paul@city-fan.org> - 77-1
- Update to 77
  - New policy Documentation::ProhibitDuplicateHeadings
  - Fix POD parse losing violations across =cut gaps

* Sat Jan 19 2013 Paul Howarth <paul@city-fan.org> - 76-1
- Update to 76
  - RequireNumericVersion explicit check for exponential strings, e.g. "1e6"

* Sat Nov 24 2012 Paul Howarth <paul@city-fan.org> - 75-1
- Update to 75
  - ProhibitEmptyCommas fix for [{%%a},{}] (CPAN RT#81390)

* Mon Oct 29 2012 Paul Howarth <paul@city-fan.org> - 74-1
- Update to 74
  - Skip version.pm 1e6 test in RequireNumericVersion.t for now

* Thu Jun 28 2012 Paul Howarth <paul@city-fan.org> - 73-1
- Update to 73
  - Tests fix for File::Temp in perl pre-5.10 (CPAN RT#78053)
- Drop patch for building with old File::Temp, no longer needed

* Tue Jun 26 2012 Paul Howarth <paul@city-fan.org> - 72-3
- Import from Fedora

* Wed Jun 20 2012 Petr Pisar <ppisar@redhat.com> - 72-2
- Perl 5.16 rebuild

* Tue Jun 19 2012 Petr Pisar <ppisar@redhat.com> - 72-1
- 72 bump

* Wed Jun 06 2012 Petr Pisar <ppisar@redhat.com> - 71-1
- 71 bump

* Fri May 18 2012 Petr Pisar <ppisar@redhat.com> - 70-1
- 70 bump

* Mon Jan 30 2012 Petr Pisar <ppisar@redhat.com> - 69-1
- 69 bump

* Fri Jan 27 2012 Petr Pisar <ppisar@redhat.com> - 68-1
- 68 bump

* Fri Jan 13 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 67-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Mon Dec 19 2011 Petr Pisar <ppisar@redhat.com> - 67-1
- 67 bump

* Mon Dec 12 2011 Petr Pisar <ppisar@redhat.com> - 66-1
- 66 bump

* Mon Sep 19 2011 Petr Pisar <ppisar@redhat.com> - 65-1
- 65 bump

* Mon Aug 22 2011 Petr Pisar <ppisar@redhat.com> - 64-1
- 64 bump

* Tue Jul 26 2011 Petr Pisar <ppisar@redhat.com> - 62-1
- 62 bump
- Remove RPM 4.8 filters

* Tue Jul 26 2011 Marcela Mašláňová <mmaslano@redhat.com> - 61-3
- add RPM4.9 macro filter

* Tue Jul 19 2011 Petr Sabata <contyk@redhat.com> - 61-2
- Perl mass rebuild

* Mon Jun 06 2011 Petr Pisar <ppisar@redhat.com> - 61-1
- Version 61 bump

* Mon May 23 2011 Petr Pisar <ppisar@redhat.com> - 60-2
- Remove explicit defattr

* Mon May 23 2011 Petr Pisar <ppisar@redhat.com> - 60-1
- Version 60 bump

* Tue May 10 2011 Petr Pisar <ppisar@redhat.com> - 59-1
- Version 59 bump

* Tue May 10 2011 Petr Pisar <ppisar@redhat.com> - 58-1
- Version 58 bump

* Fri May 06 2011 Petr Pisar <ppisar@redhat.com> - 57-1
- Version 57 bump

* Thu Apr 28 2011 Petr Pisar <ppisar@redhat.com> - 56-1
- Version 56 bump
- Do not provide private parsers

* Tue Apr 26 2011 Petr Pisar <ppisar@redhat.com> - 55-1
- Version 55 bump

* Thu Apr 21 2011 Petr Pisar <ppisar@redhat.com> - 54-1
- 54 bump

* Thu Apr 21 2011 Petr Pisar <ppisar@redhat.com> - 51-1
- Version 51 bump

* Thu Apr 21 2011 Petr Pisar <ppisar@redhat.com> - 46-2
- Do not provide Perl::MinimumVersion

* Tue Jan 25 2011 Petr Pisar <ppisar@redhat.com> 46-1
- Specfile autogenerated by cpanspec 1.78
- Remove BuidRoot stuff
- Install into perl core direcotory
- Make the package no-architecture depndend (the XS compilation is test-time)
